local basic = require("lib.basic")

--secure digging wrappers
local function secureDig()
  while turtle.detect() do 
    turtle.dig() 
  end
end
local function secureDigUp()
  while turtle.detectUp() do 
    turtle.digUp() 
  end
end
local function secureDigDown()
  while turtle.detectDown() do 
    turtle.digDown() 
  end
end



--location returning move wrapper
--https://www.youtube.com/watch?v=bZe5J8SVCYQ

local function savePos()
  basic.writeToFile("brulijam/files/pos.txt", textutils.serialize(state))
end

local function getPos()
  if not fs.exists "brulijam/files/pos.txt" then
    basic.clearDisplay()
    print("[Postion init]")

    write("x: ")
    x = read()
    write("y: ")
    y = read()
    write("z: ")
    z = read()
    write("r (S=0,W=1,N=2,E=3):")
    r = read()
    basic.clearDisplay()

    pos = {}
    pos["x"] = x
    pos["y"] = y
    pos["z"] = z
    pos["r"] = r
    basic.writeToFile("brulijam/files/pos.txt", textutils.serialize(pos))
  else
    pos = basic.readFileAll("brulijam/files/pos.txt")
    pos = textutils.unserialize(pos)
  end
  return pos
end

local function forward()
  if turtle.forward() then
    local pos = getPos()
    sleep(1)
    if pos["r"] == 0 then
      pos["z"] = pos["z"] + 1
    elseif pos["r"] == 1 then
      pos["x"] = pos["x"] - 1
    elseif pos["r"] == 2 then
      pos["z"] = pos["z"] - 1
    elseif pos["r"] == 3 then
      pos["x"] = pos["x"] + 1
    end
  end
end

local function back()
  sleep(1)
  if turtle.back() then
    if pos["r"] == 0 then
      pos["z"] = pos["z"] - 1
    elseif pos["r"] == 1 then
      pos["x"] = pos["x"] + 1
    elseif pos["r"] == 2 then
      pos["z"] = pos["z"] + 1
    elseif pos["r"] == 3 then
      pos["x"] = pos["x"] - 1
    end
  end
end

local function up()
  sleep(1)
  if turtle.up() then
    pos["y"] = pos["y"] + 1
  end
end

local function down()
  sleep(1)
  if turtle.down() then
    pos["y"] = pos["y"] - 1
  end
end

local function left()
  sleep(1)
  if turtle.turnLeft() then
    pos["r"] = (pos["r"]-1) % 4
  end
end

local function right()
  sleep(1)
  if turtle.turnRight() then
    pos["r"] = (pos["r"]+1) % 4
  end
end



return
{
  secureDig=secureDig,
  secureDigUp=secureDigUp,
  secureDigDown=secureDigDown,
  forward=forward,
  back=back,
  up=up,
  down=down,
  left=left,
  right=right,
  getPos=getPos,
}