if not fs.exists "bos/lib/aes.lua" then
  shell.run("pastebin get bkege8fc bos/lib/aes.lua")
end
--aes = require("bos.lib.aes") --aes does not yet work with require
os.loadAPI("bos/lib/aes.lua")

if not fs.exists "bos/lib/hash.lua" then
  shell.run("pastebin get DVLAZ4K7 bos/lib/hash.lua")
end
hash = require("bos.lib.hash")

local function write_to_file(file, content)
  file = fs.open(file, "w")
  file.write(content)
  file.close()
end

local function read_file_oneline(file)
  file = fs.open(file, "r")
  data = file.readLine()
  file.close()
  if (data == "true") then data = true elseif data == "false" then data = false end
  return data
end

local function clear_display()
  term.clear()
  term.setCursorPos(1,1)
end

local function create_keyfile()
  clear_display()
  write("Please enter shared secret for networking: ")
  local pw_hash = hash.digestStr(read("*") .. "salty salt")
  write_to_file("bos/files/networking-key.txt", pw_hash)
  clear_display()
end

local function setup()
  print(">starting sync-client-setup")
  from = os.computerLabel()
  peripheral.find("modem", rednet.open)
  if not fs.exists "bos/files/networking-key.txt" then
    create_keyfile()
  end
  print(">sync-client-setup finished")
  sleep(2)
end

local function get_keyfile()
  pw_hash = read_file_oneline("bos/files/networking-key.txt")
  return pw_hash
end

local function receive_message()
  keyfile = get_keyfile()
  id, rec_msg, prot = rednet.receive()
  pcall_success, decr_msg = pcall(aes.decrypt, keyfile, rec_msg)

  if pcall_success and decr_msg ~= nil then
    rec_table = textutils.unserialize(decr_msg)

    if rec_table[1] == from then
      if rec_table[2] == "file_transfer" then
        write_to_file(rec_table[3][0], rec_table[3][1])
        return "event: received " .. rec_table[3][0]
      end

      return rec_table
    end
  else
    return "event: unencrypted message"
  end
end

function send_message(to, what, payload)
  setup()
  keyfile = get_keyfile()
  local msg_table = {}
  msg_table[0] = from
  msg_table[1] = to
  msg_table[2] = what
  msg_table[3] = payload

  enc_msg = aes.encrypt(keyfile, textutils.serialize(msg_table))
  rednet.broadcast(enc_msg)
end

setup()
print(">modem required")
while true do
  print(receive_message())
end
