-- This version does not use the gps module because it sometimes fails on servers when no one is online



basic = require("lib.basic")
tutel = require("lib.tutel")
networking = require("lib.networking")

oreList = {
  [0] = "minecraft:gold_ore",
  [1] = "minecraft:deepslate_gold_ore",
  [2] = "minecraft:iron_ore",
  [3] = "minecraft:deepslate_iron_ore",
  [4] = "minecraft:coal_ore",
  [5] = "minecraft:deepslate_coal_ore",
  [6] = "minecraft:lapis_ore",
  [7] = "minecraft:deepslate_lapis_ore",
  [8] = "minecraft:diamond_ore",
  [9] = "minecraft:deepslate_diamond_ore",
  [10] = "minecraft:redstone_ore",
  [11] = "minecraft:deepslate_redstone_ore",
  [12] = "minecraft:emerald_ore",
  [13] = "minecraft:deepslate_emerald_ore",
  [14] = "minecraft:nether_quartz_ore",
  [15] = "minecraft:nether_gold_ore",
  [16] = "minecraft:copper_ore",
  [17] = "minecraft:deepslate_copper_ore",
  [18] = "minecraft:ancient_debris",
}

keepList = {
  [0] = "computercraft:wireless_modem_advanced",
  [1] = "minecraft:chest",
  [2] = "minecraft:barrel",
  [3] = "minecraft:raw_gold",
  [4] = "minecraft:raw_iron",
  [5] = "minecraft:coal",
  [6] = "minecraft:lapis_lazuli",
  [7] = "minecraft:diamond",
  [8] = "minecraft:redstone",
  [9] = "minecraft:emerald",
  [10] = "minecraft:quartz",
  [11] = "minecraft:gold_nugget",
  [12] = "minecraft:ancient_debris",
  [13] = "minecraft:raw_copper",
}





local function setState()
  basic.writeToFile("brulijam/files/state-t-fiboMiner.txt", textutils.serialize(state))
  sleep(0.1)
end

local function getState()
  if not fs.exists "brulijam/files/state-t-fiboMiner.txt" then
    state = {}
    state["dataCurrentFibo"] = 2
    state["dataGoalRows"] = 0
    state["dataGoalPathProgress"] = 0
    state["dataCurrentRow"] = 0
    state["dataCurrentPathProgress"] = 0
    state["x"] = 0
    state["y"] = 0
    state["z"] = 0
    state["r"] = 0 --towards south (pos Z)
    state["startX"] = 0
    state["startY"] = 0
    state["startZ"] = 0
    

    basic.writeToFile("brulijam/files/state-t-fiboMiner.txt", textutils.serialize(state))
  else
    state = basic.readFileAll("brulijam/files/state-t-fiboMiner.txt")
    state = textutils.unserialize(state)
  end
  return state
end


local function savePos(prefix)
  --save position to file and ntfy
  basic.appendToFileNl("/brulijam/files/chests-turtle-miner-fibo.txt", prefix .. state["x"] .. ", " .. state["y"]+1 .. ", " .. state["z"])
  basic.ntfy("[" .. os.getComputerLabel() .. "](Mining) " .. prefix .. state["x"] .. ", " .. state["y"]+1 .. ", " .. state["z"])
end

local function inventoryRework()
  chestAvailable = false
  chestSlot = 0
  spaceAvailable = false

  for i=1, 16 do
    turtle.select(i)
    itemDetail = turtle.getItemDetail()
    if itemDetail ~= nil then
      if itemDetail.name == "minecraft:coal" then
        turtle.refuel()
        spaceAvailable = true
      elseif itemDetail.name == "minecraft:chest" or itemDetail.name == "minecraft:barrel" then
        chestAvailable = true
        chestSlot = i
      else --check if item can be thrown away
        keepItem = false
        for j=0, #keepList do
          if itemDetail.name == keepList[j] then
            keepItem = true
          end
        end
        if not keepItem then
          turtle.dropDown()
          spaceAvailable = true
        end
      end
    else --at least one slot of space remaining
      spaceAvailable = true
    end
  end

  --store items away
  if not spaceAvailable and chestAvailable then
    --turtle.up()
    state["y"] = tutel.up(state["y"])
    setState(state)
    basic.secureDigUp()
    --turtle.up()
    state["y"] = tutel.up(state["y"])
    setState(state)
    basic.secureDigUp()
    turtle.select(chestSlot)
    turtle.placeUp()
    savePos("Chest placed at ")

    for k=1, 16 do
      turtle.select(k)
      itemDetail = turtle.getItemDetail()
      if itemDetail ~= nil then
        if itemDetail.name ~= "minecraft:chest" and itemDetail.name ~= "minecraft:barrel" and itemDetail.name ~= "computercraft:wireless_modem_advanced" then
          turtle.dropUp()
        end
      end
    end
    --turtle.down()
    state["y"] = tutel.down(state["y"])
    setState(state)
    --turtle.down()
    state["y"] = tutel.down(state["y"])
    setState(state)
  end

  if not spaceAvailable and not chestAvailable then
    savePos("Turtle stopped")
    shell.run("delete /brulijam/task.lua")
    shell.run("reboot")
  end
end


local function isOre(blockData)
  for i=0, #oreList do
    if blockData["name"] == oreList[i] then
      inventoryRework()
      return true
    end
  end
  return false
end

local function recursiveOreMining()
  for i=0, 3 do
    --turtle.turnLeft()
    state["r"] = tutel.left(state["r"])
    setState(state)
    blockFound, blockData = turtle.inspect()
    if isOre(blockData) then
      tutel.secureDig()
      --turtle.forward()
      state["x"], state["y"], state["z"], state["r"] = tutel.forward(state["x"],state["y"],state["z"],state["r"])
      setState(state)
      recursiveOreMining()
      --turtle.back()
      state["x"], state["y"], state["z"], state["r"] = tutel.back(state["x"],state["y"],state["z"],state["r"])
      setState(state)
    end
  end

  blockFound, blockData = turtle.inspectUp()
  if isOre(blockData) then
    tutel.secureDigUp()
    --turtle.up()
    state["y"] = tutel.up(state["y"])
    setState(state)
    recursiveOreMining()
    --turtle.down()
    state["y"] = tutel.down(state["y"])
    setState(state)
  end

  blockFound, blockData = turtle.inspectDown()
  if isOre(blockData) then
    tutel.secureDigDown()
    --turtle.down()
    state["y"] = tutel.down(state["y"])
    setState(state)
    recursiveOreMining()
    --turtle.up()
    state["y"] = tutel.up(state["y"])
    setState(state)
  end
end

local function mineRow()
  --mine a 3 Block high Tunnel for <distance> Blocks
  for i=state["dataCurrentPathProgress"], state["dataGoalPathProgress"]-2 do
    print("row: " .. state["dataCurrentRow"]+1 .. "/" .. state["dataGoalRows"] .. ", pathProgress: " .. state["dataCurrentPathProgress"]+1 .. "/" .. state["dataGoalPathProgress"])
    
    tutel.secureDig()
    --turtle.forward()
    state["x"], state["y"], state["z"], state["r"] = tutel.forward(state["x"],state["y"],state["z"],state["r"])
    setState(state)
    tutel.secureDigUp()
    tutel.secureDigDown()

    --clearInventory()
    --inventoryRework()

    --check current mining step for ore
    --turtle.up()
    state["y"] = tutel.up(state["y"])
    setState(state)
    recursiveOreMining()
    --turtle.down()
    state["y"] = tutel.down(state["y"])
    setState(state)
    recursiveOreMining()
    --turtle.down()
    state["y"] = tutel.down(state["y"])
    setState(state)
    recursiveOreMining()
    --turtle.up()
    state["y"] = tutel.up(state["y"])
    setState(state)
    
    inventoryRework()
    --clearInventory()
    --checkInventory()
    
    --save path progress
    state["dataCurrentPathProgress"] = i+1
    setState(state)
  end
  print("row: " .. state["dataCurrentRow"]+1 .. "/" .. state["dataGoalRows"] .. ", pathProgress: " .. state["dataCurrentPathProgress"]+1 .. "/" .. state["dataGoalPathProgress"])
end

local function mineChunk()
  state = getState()

  state["dataGoalRows"] = state["dataCurrentFibo"]
  state["dataGoalPathProgress"] = 3*(state["dataCurrentFibo"]-1)+1
  setState(state)

  for i=state["dataCurrentRow"], state["dataGoalRows"]-1 do
    sleep(0.5)
    mineRow(state["dataGoalPathProgress"])
    
    --turn back and return to start of row if not last row
    if i<state["dataGoalRows"]-1 then
      --turtle.turnLeft()
      state["r"] = tutel.left(state["r"])
      setState(state)
      --turtle.turnLeft()
      state["r"] = tutel.left(state["r"])
      setState(state)

      for j=1, state["dataGoalPathProgress"]-1 do
        --turtle.forward()
        state["x"], state["y"], state["z"], state["r"] = tutel.forward(state["x"],state["y"],state["z"],state["r"])
        setState(state)
      end

      --go to next row
      --turtle.turnLeft()
      state["r"] = tutel.left(state["r"])
      setState(state)
      for j=0, 2 do
        tutel.secureDig()
        --turtle.forward()
        state["x"], state["y"], state["z"], state["r"] = tutel.forward(state["x"],state["y"],state["z"],state["r"])
        setState(state)
        tutel.secureDigUp()
        tutel.secureDigDown()
      end
      --turtle.turnLeft()
      state["r"] = tutel.left(state["r"])
      setState(state)
    end
    
    state["dataCurrentRow"] = i+1
    state["dataCurrentPathProgress"] = 0
  end

  --reset row progress
  state["dataCurrentRow"] = 0
end

local function mineFibo()
  state = getState()

  while true do
    mineChunk()

    --go to next chunk
    --turtle.turnRight()
    state["r"] = tutel.right(state["r"])
    setState(state)
    for j=1, 2 do
      tutel.secureDig()
      --turtle.forward()
      state["x"], state["y"], state["z"], state["r"] = tutel.forward(state["x"],state["y"],state["z"],state["r"])
      setState(state)
      tutel.secureDigUp()
      tutel.secureDigDown()
    end

    --get next fibo number
    state["dataCurrentFibo"] = math.floor((state["dataCurrentFibo"] * (1+math.sqrt(5))/2) + 0.5)
    setState(state)
  end
end

if fs.exists "brulijam/files/state-t-fiboMiner.txt" then
  --setup()
  mineFibo()
else
  state = getState()

  write("x: ")
  startX = read()
  write("y: ")
  startY = read()
  write("z: ")
  startZ = read()
  write("r (S=0,W=1,N=2,E=3):")
  startR = read()

  state["x"] = startX
  state["y"] = startY
  state["z"] = startZ
  state["r"] = startR
  
  state["startX"] = startX
  state["startY"] = startY
  state["startZ"] = startZ
  setState(state)
end
  