function error()
    print(Error)
    read()
end

function getStartPosition()

    local file = fs.open("logistics/startPosition","r")
    local data = file.readLine()
    file.close()
    startPosition = data
end


function saveStartPosition(startPosition)

    local file = fs.open("logistics/startPosition","w")
    file.write(startPosition)
    file.close()
end




function getStorageContent()

    local file = fs.open("logistics/storageContent","r")
    local data = file.readAll()
    file.close()
    storageContent = textutils.unserialize(data)
end


function saveStorageContent()

    local file = fs.open("logistics/storageContent","w")
    file.write(textutils.serialize(storageContent))
    file.close()
end

function createStorageContentMatrix(d,w,h)

    storageContent = {}

    for i=1, d do
        storageContent[i] = {}

        for j=1, w do
            storageContent[i][j] = {}

            for k=1, h do
                storageContent[i][j][k] = {"empty", 0}
            end
        end
    end
end






function chooseChestToGoTo()

    if not exist "logistics/storageContent" then

        createStorageContentMatrix()
    else

        getStorageContent()
    end


    for i=1, #storageContent do
        for j=1, #storageContent[i] do
            for k=1, #storageContent[i][j] do

                if (storageContent[i][j][k][1] == itemDetail.name) and (storageContent[i][j][k][2] < 1664) then
                    return i,j,k
                end
            end
        end
    end


    for i=1, #storageContent do
        for j=1, #storageContent[i] do
            for k=1, #storageContent[i][j] do

                if (storageContent[i][j][k][1] == "empty") and (storageContent[i][j][k][2] == 0) then
                    return i,j,k
                <else>
                    print("Lagerplatz nicht ausreichend.")
                    error()
                end
            end
        end
    end
end






function goToChosenChest(d,w,h)

    -- d
    turtle.left()
    turtle.left()

    for x=1, d do

        turtle.forward()
        turtle.forward()
    end

    turtle.back()
    turtle.back()

    -- w
    turtle.right()

    for y=1, w do

        turtle.forward()
    end

    -- h
    turtle.left()

    for z=1, h do

        turtle.up()
    end
end






function goToStartChest()

    turtle.left()
    while not (turtl.detect()) do
        turtle.forward()
    end
    turtle.left()
    while not (turtl.detect()) do
        turtle.forward()
    end
    while not (turtl.detectDown()) do
        turtle.down()
    end
    if (turtlePosition ~= startPosition) then
        print("Turtle nicht bei Startposition.")
        error()
    end
end






function sortSlotInStorage()

    d,w,h = chooseChestToGoTo()
    goToChosenChest(d,w,h)


    local spaceInChest == 1728 - storageContent[d][w][h][2]

    if (spaceInChest > 0) then

        itemDetailCount = itemDetail.count

        turtle.drop()

        storageContent[d][w][h][1] = itemDetail.name
        storageContent[d][w][h][2] = storageContent[d][w][h][2] + itemDetailCount
        saveStorageContent()
    end

    goToStartChest()
end






function sortChestInStorage()

    for i=1, 16 do

        turtle.suck(64)
    end

    for i=1, 16 do

        turtle.select(i)
        itemDetail = turtle.getItemDetail()

        if itemDetail then
            sortSlotInStorage()
        end
    end
end






function refuelIfNeeded()

    while (turtle.getFuelLevel() <= 1000) do

        print("Wenig Treibstoff. Items werden nicht wegsortiert.")
        write("Wenn die Turtle sich nachfüllen soll, dann gebe \"refuel all\" ein: ")
        doRefuel = read()
        if (doRefuel == "refuel all") then
            for i=1, 16 do
                turtle.select(i)
                turtle.refuel(64)
            end
        end
    end
end








--##########--
--##########--
--[[ Main ]]--
--##########--
--##########--

if not (fs.exists("logistics/startPosition")) then

    write("Start Position der Turtle: ")
    startPosition = read()
    saveStartPosition(startPosition)
end

turtlePosition = gps.locate()

while true do

    if (turtlePosition ~= startPosition) then

        goToStartChest()

    else

        refuelIfNeeded()

        while (turtle.suck()) do

            sortChestInStorage()
    
        end
    end

    print("Waiting for Items")
    sleep(60)
end